package cc.fascinated.bat.features.base.commands.general;

import cc.fascinated.bat.command.BatCommand;
import cc.fascinated.bat.command.CommandInfo;
import cc.fascinated.bat.common.EmbedUtils;
import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.BatUser;
import lombok.NonNull;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.channel.middleman.MessageChannel;
import net.dv8tion.jda.api.interactions.commands.SlashCommandInteraction;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
@CommandInfo(name = "vote", description = "Vote for the bot", guildOnly = false)
public class VoteCommand extends BatCommand {
    private static final String[] VOTE_LINKS = new String[]{
            "https://top.gg/bot/1254161119975833652/vote",
            "https://discordbotlist.com/bots/bat/upvote"
    };

    @Override
    public void execute(BatGuild guild, @NonNull BatUser user, @NonNull MessageChannel channel, Member member, @NonNull SlashCommandInteraction event) {
        StringBuilder builder = new StringBuilder();
        builder.append("You can vote for the bot by clicking the following links:\n\n");
        for (String link : VOTE_LINKS) {
            builder.append("%s\n".formatted(link));
        }
        event.replyEmbeds(EmbedUtils.genericEmbed()
                .setDescription(builder.toString())
                .build()
        ).queue();
    }
}
